/* Wake AESSYS up at regular intervals */

#include <stdio.h>
#include <signal.h>
#include <osbind.h>
#include <ostruct.h>
#include <mintbind.h>
#include <atarierr.h>
#include <gem.h>
#include <portlib.h>
#include <sys/syslog.h>

#define GEMNAME		"  WakeGEM II"	/* user visible name */
#define SYSNAME		"wakegemd"		/* for logs */
#define INTERVAL	3000			/* milliseconds */

extern void syslog();
extern void openlog();
extern void closelog();

short aespid;
volatile short quit = 0;
long actions = 0;

static void alarm()
{
	if (Pkill(aespid, SIGCONT) != E_OK) {
		syslog(LOG_ERR, "error sending signal");
		quit = 1;
	}
}

static void term()
{
	quit = 1;
	syslog(LOG_INFO, "caught term signal");
}

int main()
{
	register short apid = appl_init(), tmp;

	openlog(SYSNAME, LOG_PID, LOG_DAEMON);
	syslog(LOG_INFO, "starting up");
	if (apid > 0) {
		(void)Pnice(20);
		if ((tmp = appl_find("AESSYS  ")) > -1) {
			aespid = appl_find((void *)(0xfffe0000|tmp));
			if (aespid > 0 && Pkill(aespid, SIGNULL) == E_OK) {
				menu_register(apid, GEMNAME);

				Psigsetmask(0x00000003L);
				Psignal(SIGINT, &term);
				Psignal(SIGQUIT, &term);
				Psignal(SIGTERM, &term);
				Psignal(SIGALRM, &alarm);

				while(!quit) {
					Tmalarm(INTERVAL);
					Pause();
				}
			}
			else
				syslog(LOG_ERR, "cannot talk to AES");
		}
		else
			syslog(LOG_ERR, "AES not found");

		appl_exit();
	}
	else
		syslog(LOG_ERR, "appl_init() failure");

	syslog(LOG_INFO, "exiting");
	closelog();

	return 0;
}
